<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

class plgJshoppingCheckoutDefault_group extends JPlugin {
    
    const ADDON_PATH = '/components/com_jshopping/addons/default_group/';
    const ADDON_ALIAS = 'default_group';
    const CLIENT_TYPE_INDIVIDUAL = 1;
    const CLIENT_TYPE_COMPANY = 2;
    
	public function onBeforeRegister(&$post, &$default_usergroup){
        require_once JPATH_ROOT . self::ADDON_PATH . self::ADDON_ALIAS . '.php';
        
        $addon = new AddonDefaultGroup();
        $params = $addon->getAddonParams();

        if ((isset($post['client_type']) && $post['client_type'] == self::CLIENT_TYPE_INDIVIDUAL) || !$post['client_type']){
            if ($params['defoult_group']){
                $default_usergroup = $params['defoult_group'];
            }
        }

        if (isset($post['client_type']) && $post['client_type'] == self::CLIENT_TYPE_COMPANY){
            if ($params['defoult_group_firm']){
                $default_usergroup = $params['defoult_group_firm'];
            }
        }
	}

    public function editGroup(){

        require_once JPATH_ROOT . self::ADDON_PATH . self::ADDON_ALIAS . '.php';
        $addon = new AddonDefaultGroup();
        $params = $addon->getAddonParams();
        $adv_user = \JSFactory::getUser();
		
		if($adv_user->user_id <= 0){
            return;
        }
		
        $post = \JFactory::getApplication()->input->post->getArray();
        $client_type = $this->type_client;
        if (isset($post['client_type']) && $client_type != $post['client_type']){
            $adv_user->load($adv_user->user_id);
            $user = new JUser($adv_user->user_id);
            $data = array();
            
            if ($post['client_type'] == self::CLIENT_TYPE_INDIVIDUAL){
                $adv_user->usergroup_id = $params['defoult_group'];
                $data['groups'] = $params['default_groups_joomla'];
            }     
            if ($post['client_type'] == self::CLIENT_TYPE_COMPANY){
                $adv_user->usergroup_id = $params['defoult_group_firm']; 
                $data['groups'] = $params['default_groups_joomla_company'];
            }
			if (is_array($data['groups']) && count($data['groups'])){
				$user->bind($data);      
				$user->save();
			}
			$adv_user->store();          
        }
    }

    public function onAfterAccountSave(){
        
        $this->editGroup(); 
    }

    public function onBeforeAccountSave(&$post){
        
        $adv_user = \JSFactory::getUserShop()->loadDataFromEdit();
        $this->type_client = $adv_user->client_type;
    }
    
    public function onAfterSaveCheckoutStep2(){

        $this->editGroup();
    }

    public function onLoadCheckoutStep2save(){
        
        $adv_user = \JSFactory::getUserShop()->loadDataFromEdit();
        $this->type_client = $adv_user->client_type;
    }

    public function onJoomlaComponentJshoppingSiteModelUserregisterModelUserJoomlaSaveBeforeBind(&$model, &$vars){
        require_once JPATH_ROOT . self::ADDON_PATH . self::ADDON_ALIAS . '.php';

        $addon = new AddonDefaultGroup();
        $params = $addon->getAddonParams();
        
        if ((isset($vars['post']['client_type']) && $vars['post']['client_type'] == self::CLIENT_TYPE_INDIVIDUAL) || !$vars['post']['client_type']){
            if (is_array($params['default_groups_joomla']) && count($params['default_groups_joomla'])){
                $vars['data']['groups'] = $params['default_groups_joomla'];
            }
        }
        
        if (isset($vars['post']['client_type']) && $vars['post']['client_type'] == self::CLIENT_TYPE_COMPANY){
            if (is_array($params['default_groups_joomla_company']) && count($params['default_groups_joomla_company'])){
                $vars['data']['groups'] = $params['default_groups_joomla_company'];
            }
        }
    }
}